package eu.eudat.commons.types.dmpblueprint;

import eu.eudat.commons.enums.DmpBlueprintFieldCategory;
import eu.eudat.commons.enums.ReferenceTypeSourceType;
import eu.eudat.commons.types.referencetype.ReferenceTypeSourceBaseConfigurationEntity;
import eu.eudat.commons.types.referencetype.ReferenceTypeSourceExternalApiConfigurationEntity;
import eu.eudat.commons.types.referencetype.ReferenceTypeSourceStaticOptionConfigurationEntity;
import eu.eudat.commons.types.xml.XmlBuilder;
import eu.eudat.commons.types.xml.XmlSerializable;
import jakarta.xml.bind.annotation.*;
import org.w3c.dom.Document;
import org.w3c.dom.Element;
import org.w3c.dom.Node;
import org.w3c.dom.NodeList;

import java.util.LinkedList;
import java.util.List;
import java.util.UUID;
import java.util.stream.Collectors;

@XmlAccessorType(XmlAccessType.FIELD)
public class SectionEntity {

    @XmlAttribute(name="id")
    private UUID id;

    @XmlAttribute(name="label")
    private String label;

    @XmlAttribute(name="description")
    private String description;

    @XmlAttribute(name="ordinal")
    private Integer ordinal;

    @XmlElementWrapper(name = "fields")
    @XmlElements({
            @XmlElement(name = DmpBlueprintFieldCategory.Names.Extra, type = ExtraFieldEntity.class),
            @XmlElement(name = DmpBlueprintFieldCategory.Names.System, type = SystemFieldEntity.class),
    })
    private List<FieldEntity> fields;
    
    @XmlAttribute(name="hasTemplates")
    private Boolean hasTemplates;
    
    @XmlElementWrapper(name = "descriptionTemplates")
    @XmlElement(name = "descriptionTemplate")
    private List<DescriptionTemplateEntity> descriptionTemplates;

    public UUID getId() {
        return id;
    }
    public void setId(UUID id) {
        this.id = id;
    }

    public String getLabel() {
        return label;
    }
    public void setLabel(String label) {
        this.label = label;
    }

    public String getDescription() {
        return description;
    }
    public void setDescription(String description) {
        this.description = description;
    }

    public Integer getOrdinal() {
        return ordinal;
    }
    public void setOrdinal(Integer ordinal) {
        this.ordinal = ordinal;
    }

    public List<FieldEntity> getFields() {
        return fields;
    }
    public void setFields(List<FieldEntity> fields) {
        this.fields = fields;
    }

    public Boolean getHasTemplates() {
        return hasTemplates;
    }
    public void setHasTemplates(Boolean hasTemplates) {
        this.hasTemplates = hasTemplates;
    }

    public List<DescriptionTemplateEntity> getDescriptionTemplates() {
        return descriptionTemplates;
    }
    public void setDescriptionTemplates(List<DescriptionTemplateEntity> descriptionTemplates) {
        this.descriptionTemplates = descriptionTemplates;
    }

}
