package eu.eudat.integrationevent.outbox.notification;

import eu.eudat.integrationevent.outbox.OutboxIntegrationEvent;
import eu.eudat.integrationevent.outbox.OutboxService;
import gr.cite.tools.auditing.AuditService;
import gr.cite.tools.data.query.QueryFactory;
import gr.cite.tools.logging.LoggerService;
import gr.cite.tools.validation.ValidatorFactory;
import org.slf4j.LoggerFactory;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.stereotype.Component;
import org.springframework.web.context.annotation.RequestScope;

import javax.management.InvalidApplicationException;
import java.util.UUID;

@Component
@RequestScope
public class NotifyIntegrationEventHandlerImpl implements NotifyIntegrationEventHandler {

    private static final LoggerService logger = new LoggerService(LoggerFactory.getLogger(NotifyIntegrationEventHandlerImpl.class));

    private final QueryFactory queryFactory;

    private final AuditService auditService;

    private final OutboxService outboxService;

    private final ValidatorFactory validatorFactory;

    @Autowired
    public NotifyIntegrationEventHandlerImpl(
            OutboxService outboxService,
            QueryFactory queryFactory,
            AuditService auditService, ValidatorFactory validatorFactory) {
        this.outboxService = outboxService;
        this.validatorFactory = validatorFactory;
        this.queryFactory = queryFactory;
        this.auditService = auditService;
    }

    @Override
    public void handle(NotifyIntegrationEvent event) throws InvalidApplicationException {
		OutboxIntegrationEvent message = new OutboxIntegrationEvent();
		message.setMessageId(UUID.randomUUID());
		message.setType(OutboxIntegrationEvent.NOTIFY);
		message.setEvent(event);
		this.outboxService.publish(message);
    }
}
