package eu.eudat.service.fielddatahelper;

import eu.eudat.commons.enums.FieldType;
import eu.eudat.model.persist.descriptiontemplatedefinition.fielddata.LabelDataPersist;
import gr.cite.tools.data.builder.Builder;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.beans.factory.config.ConfigurableBeanFactory;
import org.springframework.context.ApplicationContext;
import org.springframework.context.annotation.Scope;
import org.springframework.stereotype.Component;

@Component
public class FieldDataHelperServiceProvider {

	@Autowired
	private ApplicationContext applicationContext;
	
	public  FieldDataHelperService get(FieldType type){
		BaseFieldDataHelperService<?, ?, ?, ? > item = null;
		
		switch (type) {
			case DATA_REPOSITORIES:
			case PUB_REPOSITORIES:
			case JOURNAL_REPOSITORIES:
			case TAXONOMIES:
			case LICENSES:
			case PUBLICATIONS:
			case REGISTRIES:
			case SERVICES:
			case RESEARCHERS:
			case BOOLEAN_DECISION:
			case INTERNAL_DMP_ENTRIES_DATASETS:
			case INTERNAL_DMP_ENTRIES_DMPS:
			case INTERNAL_DMP_ENTRIES_RESEARCHERS:
			case ORGANIZATIONS: {
				item = this.applicationContext.getBean(LabelAndMultiplicityFieldDataHelperService.class);
				break;
			}
			case RADIO_BOX:  {
				item = this.applicationContext.getBean(RadioBoxFieldDataHelperService.class);
				break;
			}
			case RICH_TEXT_AREA:
			case DATE_PICKER: 
			case TEXT_AREA:  
			case FREE_TEXT:
			case TAGS:
			case DATASET_IDENTIFIER:
			case CURRENCY:
			case CHECK_BOX:
			case VALIDATION: {
				item = this.applicationContext.getBean(LabelFieldDataHelperService.class);
				break;
			} 
			case UPLOAD:  {
				item = this.applicationContext.getBean(UploadFieldDataHelperService.class);
				break;
			}
			case EXTERNAL_DATASETS:  {
				item = this.applicationContext.getBean(ExternalDatasetFieldDataHelperService.class);
				break;
			} 
			case WORD_LIST: {
				item = this.applicationContext.getBean(WordListFieldDataHelperService.class);
				break;
			}
			case AUTO_COMPLETE: {
				item = this.applicationContext.getBean(AutoCompleteFieldDataHelperService.class);
				break;
			} 
			default: throw new RuntimeException("unrecognized builder " + type.getValue());
		}
		item.setFieldType(type);
		return item;
	}
}
