package eu.eudat.service.remotefetcher;

import eu.eudat.commons.enums.ReferenceType;
import eu.eudat.commons.exceptions.HugeResultSetException;
import eu.eudat.service.remotefetcher.config.entities.GenericUrls;
import eu.eudat.service.remotefetcher.criteria.ExternalReferenceCriteria;
import gr.cite.tools.exception.MyNotFoundException;

import java.util.List;
import java.util.Map;

public interface RemoteFetcherService {
	List<Map<String, String>> getReferences(ReferenceType referenceType, ExternalReferenceCriteria externalReferenceCriteria, String key) throws MyNotFoundException, HugeResultSetException;

	GenericUrls getExternalUrls(ReferenceType referenceType);

	Integer countEntries(ExternalReferenceCriteria externalReferenceCriteria, String key) throws MyNotFoundException, HugeResultSetException;

	List<Map<String, String>> getExternalGeneric(ExternalReferenceCriteria externalReferenceCriteria, GenericUrls genericUrls);

	List<Map<String, Object>> getExternalGenericWithData(ExternalReferenceCriteria externalReferenceCriteria, GenericUrls genericUrls);
}
