package eu.eudat.logic.services;

import eu.eudat.logic.services.helpers.HelpersService;
import eu.eudat.logic.services.operations.OperationsContext;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.stereotype.Service;


@Service("apiContext")
public class ApiContextImpl implements ApiContext {

    private OperationsContext operationsContext;
    private HelpersService helpersService;

    @Autowired
    public ApiContextImpl(OperationsContext operationsContext, HelpersService helpersService) {
        this.operationsContext = operationsContext;
        this.helpersService = helpersService;
    }

    @Override
    public OperationsContext getOperationsContext() {
        return operationsContext;
    }

    @Override
    public HelpersService getHelpersService() {
        return helpersService;
    }

}
